#ifndef EXTRA_H
#define EXTRA_H

#include "UCT.h"
#include "GoBoard.h"

#include <sstream>
#include <fstream>
#include <iostream>
#include <bitset>


void dump_winrate_file(const go::UCT_node* n);

namespace go {

ostream& operator<<(ostream& os, const UCT_node& n);

position get_player_input_move(const GoBoard& board);

struct game_record {
	bitset<3 * board_size * board_size> code;
	position pos;
	int player;
	string filename;
};

void add_sgf_file(string filename, vector<game_record>& influence_map);

double get_cbr_bias(const position& p, const GoBoard& board);

position get_cbr_closest_position(const GoBoard& board);

string get_cbr_source_filename(const GoBoard& board);

}

#endif
