#ifndef INFLUENCE_H
#define INFLUENCE_H

#include "GoBoard.h"
#include <bitset>

namespace go {

struct board_influence {
	double white[board_size][board_size];
	double black[board_size][board_size];
	board_influence() {
		memset(white, 0, sizeof(white));
		memset(black, 0, sizeof(black));
	}
	double& get(int player, position p) {
		if (player == 1) {
			return black[p.y][p.x];
		} else if (player == 2) {
			return white[p.y][p.x];
		} else {
			throw string("Getting influence from unknown player: ") + player;
		}
	}
};

board_influence get_board_influence(const GoBoard& board);

void print_board_influence(const GoBoard& board, double multiplier = 1.0);

bitset<3 * board_size * board_size> get_influence_code(const GoBoard& board);

}

#endif
