#ifndef UTIL_H
#define UTIL_H

#include <sstream>

int randint(int below);

template<typename T> T random_element(const vector<T>& v) {
	assert(v.size());
	int idx = randint(v.size());
	return v[idx];
}

string operator+(const string& s, int& i);

template<typename C> string tostring(C value) {
	stringstream ss;
	ss << value;
	return ss.str();
}

namespace go {

struct position {
	short x, y;
	position(int x, int y): x(x), y(y) {
// 		if (x == -1 && y == -1) {
// 		} else {
// 			assert(x >= 0 && x < board_size);
// 			assert(y >= 0 && y < board_size);
// 		}
	}
	position() {}
	bool operator<(const position& p) const {
		if (x != p.x) return x < p.x;
		return y < p.y;
	}
	bool operator==(const position& p) const {
		if (x != p.x) return false;
		return y == p.y;
	}
	bool operator!=(const position& p) const {
		return !(*this == p);
	}
	bool is_pass() const {
		return (x == -1 && y == -1);
	}
	bool is_resign() const {
		return (x == -2 && y == -2);
	}
	bool is_move() const {
		return (x >= 0 && y >= 0);
	}
};

ostream& operator<<(ostream& os, const go::position& p);

}

string pos_to_str(const position& p);

#endif
